'Spartan Fist v1.0 script by |Farhad|
'Credits to slayerxyz for his spartan kick script

Imports System
Imports System.Windows.Forms
Imports System.Drawing
Imports GTA

Public Class SpartanKick
    Inherits Script

    Dim asMeleeAnimation As New AnimationSet("melee_player_unarmed")
    Dim pedClosestPeds() As Ped
    Dim vecKickForce As Vector3
    Dim rndDamage As New Random()
    Dim bPedKicked As Boolean = False
    Dim bObjKicked As Boolean = False
    Dim sObjKickMultiplier As Single = 20
	Dim rndAnim As New Random()

    Private Sub SpartanKick_Tick(sender As Object, e As System.EventArgs) Handles Me.Tick
        If isKeyPressed(Keys.G) Then
            pedClosestPeds = GTA.World.GetPeds(Player.Character.Position, 1.8)
            For Each P As Ped In pedClosestPeds
                If P.isInVehicle() = False Then
                    If Player.Character.isInVehicle() = False Then
                        If P.GetControllingPlayer <> Player Then
                            If Player.Character.isInAir = False Then
                                If P.Position.DistanceTo(Player.Character.Position) < 1.8 Then
                                    RequestAnimations()
                                    Player.Character.Task.ClearAll()
									if rndAnim.Next(0,2) >= 1 then
                                    GTA.Native.Function.Call("TASK_PLAY_ANIM", Player.Character, "uppercut_l", "melee_player_unarmed", 8.0, 0, 1, 1, 0, -2)
									else
									GTA.Native.Function.Call("TASK_PLAY_ANIM", Player.Character, "uppercut_r", "melee_player_unarmed", 8.0, 0, 1, 1, 0, -2)
									end if
                                    vecKickForce.X = Player.Character.Direction.X * 8.0 '8
                                    vecKickForce.Y = Player.Character.Direction.Y * 8.0 '8
                                    vecKickForce.Z = Player.Character.Direction.Z + 4.0
                                    Wait(500)
									Native.Function.Call("PLAY_SOUND_FROM_PED", -1, "MELEE_COMBAT_PED_RESPONSE_UPPERCUT_RANDOM", Player.Character)
                                    P.isRagdoll = True
                                    P.ApplyForce(vecKickForce)
                                    P.Enemy = True
                                    P.Health -= rndDamage.Next(35, 80)
                                    Dim tskAttackPlayer As New TaskSequence
                                    If P.isAliveAndWell = True Then
                                        If P.Gender = Gender.Male Then
                                            If New Random().Next(0, 20) >= 10 Then
                                                P.Task.ClearAll()
                                                tskAttackPlayer.AddTask.FightAgainst(Player)
                                                P.Task.PerformSequence(tskAttackPlayer)
                                            Else
                                                P.Task.ClearAll()
                                                tskAttackPlayer.AddTask.FleeFromChar(Player)
                                                P.Task.PerformSequence(tskAttackPlayer)
                                            End If
                                        ElseIf P.Gender = Gender.Female Then
                                            If New Random().Next(0, 20) >= 15 Then
                                                P.Task.ClearAll()
                                                tskAttackPlayer.AddTask.FightAgainst(Player)
                                                P.Task.PerformSequence(tskAttackPlayer)
                                            Else
                                                P.Task.ClearAll()
                                                tskAttackPlayer.AddTask.FleeFromChar(Player)
                                                P.Task.PerformSequence(tskAttackPlayer)
                                            End If
                                        End If
                                    End If
                                    bPedKicked = True
                                    Exit For
                                End If
                            End If
                        End If
                    End If
                End If
            Next
            If bPedKicked = False Then
                For Each Obj As GTA.Object In GTA.World.GetAllObjects()
                    If Obj.Position.DistanceTo(Player.Character.Position) < 1.8 Then
                        If Obj.Exists = True Then
                            If Player.Character.isInVehicle() = False Then
                                If Obj.Model <> Player.Character.Model Then
                                    If Obj.Model <> Model.GetWeaponModel(Player.Character.Weapons.Current) Then
                                        If Player.Character.isInAir = False Then
                                            Dim ObjMass As GTA.Native.Pointer = New GTA.Native.Pointer(GetType(Single))
                                            GTA.Native.Function.Call("GET_OBJECT_MASS", Obj, ObjMass)
                                            If ObjMass <= 80 * sObjKickMultiplier Then '8
                                                RequestAnimations()
                                                Player.Character.Task.ClearAll()
                                                if rndAnim.Next(0,2) >= 1 then
												GTA.Native.Function.Call("TASK_PLAY_ANIM", Player.Character, "uppercut_l", "melee_player_unarmed", 8.0, 0, 1, 1, 0, -2)
												else
												GTA.Native.Function.Call("TASK_PLAY_ANIM", Player.Character, "uppercut_r", "melee_player_unarmed", 8.0, 0, 1, 1, 0, -2)
												end if
                                                vecKickForce.X = Player.Character.Direction.X * 20 '30
                                                vecKickForce.Y = Player.Character.Direction.Y * 20 '30
                                                vecKickForce.Z = Player.Character.Direction.Z + 8.0
                                                Wait(500)
												Native.Function.Call("PLAY_SOUND_FROM_PED", -1, "BULLET_IMPACT_CAR_RAND", Player.Character)
                                                If Obj.Exists = True Then
                                                    Obj.ApplyForce(vecKickForce)
                                                    bObjKicked = True
                                                    Exit For
                                                End If
                                            End If
                                        End If
                                    End If
                                End If
                            End If
                        End If
                    End If
                Next
            End If
            If bObjKicked = False Then
                For Each V As Vehicle In GTA.World.GetVehicles(Player.Character.Position, 1.8)
                    If V.Position.DistanceTo(Player.Character.Position) < 1.8 Then
                        If V.Exists = True Then
                            If Player.Character.isInVehicle = False Then
                                If Player.Character.isInAir = False Then
                                    RequestAnimations()
                                    Player.Character.Task.ClearAll()
                                    if rndAnim.Next(0,2) >= 1 then
                                    GTA.Native.Function.Call("TASK_PLAY_ANIM", Player.Character, "uppercut_l", "melee_player_unarmed", 8.0, 0, 1, 1, 0, -2)
									else
									GTA.Native.Function.Call("TASK_PLAY_ANIM", Player.Character, "uppercut_r", "melee_player_unarmed", 8.0, 0, 1, 1, 0, -2)
									end if
                                    vecKickForce.X = Player.Character.Direction.X * 20 '30
                                    vecKickForce.Y = Player.Character.Direction.Y * 20 '30
                                    vecKickForce.Z = Player.Character.Direction.Z + 8.0
                                    Wait(500)
									Native.Function.Call("PLAY_SOUND_FROM_PED", -1, "BULLET_IMPACT_CAR_RAND", Player.Character)
                                    If V.Exists = True Then
                                        V.ApplyForce(vecKickForce)
                                        Exit For
                                    End If
                                End If
                            End If
                        End If
                    End If
                Next
            End If
        End If

        bPedKicked = False
        bObjKicked = False
    End Sub

    Private Sub RequestAnimations()
        GTA.Native.Function.Call("REQUEST_ANIMS", "melee_player_unarmed")
        GTA.Native.Function.Call("REQUEST_ANIMS", "melee_unarmed_base")
    End Sub
End Class